<?php
/*

Plugin Name: Galette User Sync (GUS)
Plugin URI: http://colas.sebastien.free.fr/projets/gus/
Description: This plugin allow you to synchronize WordPress users into Galette.
Version: 13.04
Author: Sebastien Colas 
License: GPL2


	Copyright 2013  Colas Sébastien  (email : colas.sebastien@free.fr)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

function update_user_in_galette($configuration,$user)
{
	global $wpdb;
	
	foreach ($configuration['field_mapping'] as $field_from => $field_to)
		if (isset($user->$field_from) && ($user->$field_from!=''))
			$data[$field_to]=$user->$field_from;
	$data['date_modif_adh']=date('Y-m-d');
	
	
	$wpdb->update( $configuration['table_name'] , $data, 
	array( $configuration['field_mapping'][$configuration['field_principal']] => $user->$configuration['field_principal'] ));
	
}

function create_user_in_galette($configuration,$user)
{
	global $wpdb;

	foreach ($configuration['field_mapping'] as $field_from => $field_to)
		$data[$field_to]=$user->$field_from;

	$data['date_crea_adh']=date('Y-m-d');
	$data['date_modif_adh']=date('Y-m-d');
	$data['activite_adh']=1;

	$wpdb->insert($configuration['table_name'],$data);
}

function synchronize($configuration,$gus_users)
{
	global $wpdb;
	foreach ($gus_users->results as $user)
	{		
		$sql="SELECT COUNT(*) FROM ".$configuration['table_name']." WHERE ".$configuration['field_mapping'][$configuration['field_principal']]."='".$user->$configuration['field_principal']."'";
		$user_count = $wpdb->get_var( $sql );
		
		switch ($user_count)
		{
			case 0:		create_user_in_galette($configuration,$user);
						update_user_meta( $user->ID, 'gus_sync_date', date('Y-m-d H:i'));
						break;
			case 1:		update_user_in_galette($configuration,$user);
						update_user_meta( $user->ID, 'gus_sync_date', date('Y-m-d H:i'));
						break;
		}
	}
}

function gus_add_custom_field( $defaults ) {
	$defaults['gus_sync'] = __('GUS', 'gus-plugin');
	return $defaults;
}

function gus_custom_field_value($value, $column_name, $id) {
	if( $column_name == 'gus_sync' ) {
		if ( current_user_can('edit_users') )
		{
			$gus_sync=get_user_meta($id, 'gus_sync',true);
			if ($gus_sync=='') $gus_sync='No';
			return __($gus_sync);
		}
	}
}

function gus_admin_page()
{
?>
<div class="wrap">
<div id="icon-tools" class="icon32"><br /></div><h2>Galette User Sync (GUS)</h2>
<?		

	global $wpdb;
	$site_url=get_option('siteurl');
	$current_url=$_SERVER['REQUEST_URI'];	
	$configuration=get_option('GUS_configuration');
	
	$action=$_POST['action'];
	
	

	switch ($action)
	{
		case 'sync':		$gus_users = new WP_User_Query( array( 'meta_key' => 'gus_sync', 'meta_value' => 'Yes') );		
							synchronize($configuration,$gus_users);
							break;
		case 'delete': 	if (is_array($_POST['list']))
								foreach ($_POST['list'] as $user_id)
									delete_user_meta( $user_id, 'gus_sync');
 							break;
		case 'add':		if (is_array($_POST['list']))
								foreach ($_POST['list'] as $user_id)
									add_user_meta( $user_id, 'gus_sync', 'Yes',true );
							break;
		case 'db_config':	if (isset($_POST['table_name']))
							{
								$configuration['table_name']=$_POST['table_name'];
								update_option( 'GUS_configuration', $configuration );
							}
							break;
		case 'add_field':	if (($_POST['field_name']!='') && ($_POST['field_value']!=''))
							{								
								if (isset ($configuration['field_mapping']))
										$configuration['field_mapping'][$_POST['field_name']]=$_POST['field_value'];  
								else 	
										$configuration['field_mapping']=array($_POST['field_name'] => $_POST['field_value']);
								update_option( 'GUS_configuration', $configuration );										
							}							
							break;
		case 'del_field':	unset($configuration['field_mapping'][$_POST['field_name']]);							
							if ($configuration['field_principal']==$_POST['field_name']) unset($configuration['field_principal']);
							update_option( 'GUS_configuration', $configuration );	
							
							break;
		case 'reset':		$configuration=array('table_name' => 'galette_adherents',
												'field_principal' => 'user_login',
												'field_mapping' => array(
		                                    		'user_login'		=>'pseudo_adh',
		                                    		'last_name' 		=> 'nom_adh',
		                                    		'first_name' 		=> 'prenom_adh',
		                                    		'user_email' 		=> 'email_adh',
		                                    		'street_address' 	=> 'adresse_adh',
		                                    		'postal_code' 		=> 'cp_adh',
		                                    		'locality' 		=> 'ville_adh',
		                                    		'phone_mobile' 	=> 'gsm_adh',
		                                    		'phone_home' 		=> 'tel_adh',
		                                    		'user_nicename' 	=> 'login_adh'
		                                    	));
							update_option( 'GUS_configuration', $configuration );
							break;
		case 'principal':	$configuration['field_principal']=$_POST['field_principal'];
							update_option( 'GUS_configuration', $configuration );
							break;
	}	
	
	if (isset($_GET['config']))
	{
?>
<form method='post'>
<input type='hidden' name='action' value='db_config'>
<h3><? _e('DataBase Configuration','gus-plugin') ?></h3>
<? _e('Gallette Member Table Name :','gus-plugin')?> <input type='text' name='table_name' value='<? echo $configuration['table_name']?>'>
<? $table_name=$configuration['table_name'];
if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name)
 echo '<b>'.__('Error','gus-plugin').'</b>'; else _e('OK','gus-plugin'); ?><br>
<input type='submit' value='<? _e('Apply','gus-plugin') ?>'>
</form>
<h3><? _e('Fields Mapping','gus-plugin') ?></h3>

<table border="1">
<tr>
  <th><? _e('WordPress User Field or Meta','gus-plugin') ?></th><th><? _e('Galette User Field','gus-plugin')?></th><th><? _e('Action','gus-plugin') ?></th>
</tr>

<? 
	if (isset ($configuration['field_mapping']))
	foreach ($configuration['field_mapping'] as $key => $value)
	{
?>		
		<form method='post'>
		<input type="hidden" name="action" value="del_field">
		<input type="hidden" name="field_name" value="<? echo $key ?>">
		<tr><td><input type="text" size="30" value="<? echo $key ?>" disabled></td><td><input type="text" size="30" value="<? echo $value ?>" disabled></td><td><input type="submit" value="<? _e('Remove','gus-plugin') ?>"></td></tr>
		</form>
<?
	}
?>
<form method='post'>
<input type='hidden' name='action' value='add_field'>
<tr><td><input type='text' size='30' name='field_name'></td><td><input type='text' size='30' name='field_value'></td><td><input type='submit' value='<? _e('Add','gus-plugin') ?>'></td></tr>
</form>
</table>
<h3><? _e('Principal Field','gus-plugin') ?></h3>
<form method='post'>
<input type='hidden' name='action' value='principal'>
<select name='field_principal'>
<? 
	if (!isset($configuration['field_principal'])) echo '<option>'.__('Please set !!!','gus-plugin').'</option>';
	if (isset($configuration['field_mapping']))
	foreach ($configuration['field_mapping'] as $key => $value)
	{
		if ($configuration['field_principal']==$key)
		echo '<option selected="selected" value='.$key.'>'.$key.'</option>';
		else
		echo '<option value='.$key.'>'.$key.'</option>';
  	} 
?>
</select>
<input type='submit' value='<? _e('Apply','gus-plugin') ?>'>
</form>

<h3><? _e('Default configuration','gus-plugin') ?></h3>
<form method='post'>
<input type='hidden' name='action' value='reset'>
<input type='submit' value='<? _e('Reset to default configuration','gus-plugin') ?>'>
</form>

<h3><? _e('Wordpress User List to Sync with Galette','gus-plugin') ?></h3>
<a href='<? echo str_replace('&config','',$current_url) ?>'><? _e('Return to Users to sync with GUS','gus-plugin') ?></a>

<?		
	}
	else
	{	
		if (!isset($gus_users))
			$gus_users = new WP_User_Query( array( 'meta_key' => 'gus_sync', 'meta_value' => 'Yes') );
		$non_gust_users = new WP_User_Query( array('meta_key'=>'gus_sync','meta_compare' => 'NOT EXISTS') );
		$all_users = get_users();	
		
		$gus_users_count=count($gus_users->results);
		$users_count=count($all_users);
		$non_gust_users_count=count($non_gust_users->results);
		
		
		if (isset($_REQUEST['users'])) $user_filter=$_REQUEST['users'];
		else $user_filter='gus';
		
		switch ($user_filter)
		{
			case 'all':	$list=$all_users;break;
			case 'gus':	$list=$gus_users->results;break;
			case 'others':	$list=$non_gust_users->results;break;
			default:		$list=null;break;
		}
		
		if (!$configuration) echo '<h3><a href="'.$current_url.'&config">'.__('Please Configure GUS','gus-plugin').'</a></h3>';
		else 
		{
			echo '<p><a href="'.$current_url.'&config">'.__('Access to GUS Configuration','gus-plugin').'</a></p>';
		
		if ($user_filter=='gus')
		{
?>
<form method='post'><input type='hidden' name='action' value='sync'><input type='submit' value='<? _e('Synchronize NOW !!!','gus-plugin')?>'></form>

<? } } ?></p>

<ul class='subsubsub'>
	<li><a href='tools.php?page=galette_user_sync.php&users=all'<? echo $user_filter=='all'?' class="current"':'' ?>><? _e('All Users','gus-plugin')?> <span class="count">(<? echo $users_count ?>)</span></a> |</li>
	<li><a href='tools.php?page=galette_user_sync.php'<? echo $user_filter=='gus'?' class="current"':'' ?>><? _e('Users sync with GUS','gus-plugin')?><span class="count">(<? echo $gus_users_count ?>)</span></a> |</li>
	<li><a href='tools.php?page=galette_user_sync.php&users=others'<? echo $user_filter=='others'?' class="current"':'' ?>><? _e('Other users','gus-plugin') ?> <span class="count">(<? echo $non_gust_users_count ?>)</span></a></li>
</ul>

<form method="post" action="<? echo $current_url ?>">

<table class="wp-list-table widefat fixed users" cellspacing="0">
	<thead>
	<tr>
		<th scope='col' id='cb' class='manage-column column-cb check-column'  style="">
		<label class="screen-reader-text" for="cb-select-all-1">Tout sélectionner</label>
		<input id="cb-select-all-1" type="checkbox" />
		</th>
		
		<th scope='col' id='username' class='manage-column column-username sortable desc'  style="">
		<!--a href="http://jav/news/wp-admin/users.php?orderby=login&#038;order=asc"-->
		<span><? _e('Username','gus-plugin') ?></span><!--span class="sorting-indicator"></span--></a>
		</th>
		
		<th scope='col' id='name' class='manage-column column-name sortable desc'  style="">
		<!--a href="http://jav/news/wp-admin/users.php?orderby=name&#038;order=asc"-->
		<span><? _e('Last Name','gus-plugin') ?></span><!--span class="sorting-indicator"></span-->
		</a>
		</th>
		
		<th scope='col' id='email' class='manage-column column-email sortable desc'  style="">
		<!--a href="http://jav/news/wp-admin/users.php?orderby=email&#038;order=asc"-->
		<span><? _e('First Name','gus-plugin') ?></span><!--span class="sorting-indicator"></span-->
		</a>
		</th>
				
		<th scope='col' id='email' class='manage-column column-email sortable desc'  style="">
		<!--a href="http://jav/news/wp-admin/users.php?orderby=email&#038;order=asc"-->
		<span><? _e('E-mail','gus-plugin') ?></span><!--span class="sorting-indicator"></span-->
		</a>
		</th>
				
		<th scope='col' id='gus_sync' class='manage-column column-gus_sync'  style="">
		<? _e('Galette User Sync','gus-plugin')?></th>

		<th scope='col' id='gus_sync' class='manage-column column-gus_sync'  style="">
		<? _e('Last Sync','gus-plugin')?></th></tr>		
	</thead>
	
	<tfoot>
	<tr>
		<th scope='col'  class='manage-column column-cb check-column'  style="">
		<label class="screen-reader-text" for="cb-select-all-2">Tout sélectionner</label>
		<input id="cb-select-all-2" type="checkbox" />
		</th>
		
		<th scope='col'  class='manage-column column-username sortable desc'  style="">
		<!--a href="http://jav/news/wp-admin/users.php?orderby=login&#038;order=asc"-->
		<span><? _e('Username','gus-plugin') ?></span><!--span class="sorting-indicator"></span--></a>
		</th>
		
		<th scope='col'  class='manage-column column-name sortable desc'  style="">
		<!--a href="http://jav/news/wp-admin/users.php?orderby=name&#038;order=asc"-->
		<span><? _e('Last Name','gus-plugin') ?></span><!--span class="sorting-indicator"></span--></a>
		</th>
		
		<th scope='col'  class='manage-column column-email sortable desc'  style="">
		<!--a href="http://jav/news/wp-admin/users.php?orderby=email&#038;order=asc"-->
		<span><? _e('First Name','gus-plugin') ?></span><!--span class="sorting-indicator"></span--></a>
		</th>

		<th scope='col'  class='manage-column column-email sortable desc'  style="">
		<!--a href="http://jav/news/wp-admin/users.php?orderby=email&#038;order=asc"-->
		<span><? _e('E-mail','gus-plugin') ?></span><!--span class="sorting-indicator"></span--></a>
		</th>
		
		<th scope='col'  class='manage-column column-gus_sync'  style=""><? _e('Galette User Sync','gus-plugin')?></th>
		<th scope='col'  class='manage-column column-gus_sync'  style=""><? _e('Last Sync','gus-plugin')?></th>
		</tr>
	</tfoot>	
	
	<tbody id="the-list" data-wp-lists='list:user'>
<? foreach ($list as $user) { ?>
		<tr id='user-1' class="alternate">
		  <th scope='row' class='check-column'><label class="screen-reader-text">Sélectionner <? echo $user->user_login ?></label><input type='checkbox' name='list[]' value='<? echo $user->ID ?>' /></th>
		  <td class="username column-username"><strong><a href="<? echo $site_url?>/wp-admin/user-edit.php?user_id=<? echo $user->ID ?>"><? echo $user->user_login ?></a></strong></td>
		  <td><? echo $user->last_name ?></td>
		  <td><? echo $user->first_name ?></td>
		  <td><a href='mailto:<? echo $user->user_email ?>' ><? echo $user->user_email ?></a></td>
		  <td><? _e($user->gus_sync); ?></td>
		  <td><? echo $user->gus_sync_date ?></td></tr>
<? } ?>		  
	</tbody>
</table>	
	<div class="tablenav bottom">
		<div class="alignleft actions">
			<select name='action'>
				<option value='-1' selected='selected'><? _e('Bulk Actions','gus-plugin')?></option>
				<option value='add'><? _e('Synchronize with GUS','gus-plugin') ?></option>
				<option value='delete'><? _e('Remove GUS Synchonization','gus-plugin') ?></option>				
			</select>
			<input type="submit" name="" class="button action" value="<? _e('Apply','gus-plugin') ?>"  />
		</div>
	</div>
</form>


<?php
	}
}

function gus_admin_panel() 
{
	if (function_exists('add_management_page')) 
	       add_management_page('Gus Administration', 'GUS', 5, basename(__FILE__), 'gus_admin_page');  
}

     
function gus_uninstall() 
{ 
    delete_option('GUS_configuration');
    $gus_users = new WP_User_Query( array( 'meta_key' => 'gus_sync', 'meta_value' => 'Yes') );
    if ($gus_users->results)
    	foreach ($gus_users->results as $gus_user)
    		delete_user_meta($gus_user->ID,'gus_sync');
}

function gus_init() {
	$plugin_dir = basename(dirname(__FILE__));
	load_plugin_textdomain( 'gus-plugin', false, $plugin_dir );
}

// Ajout du champ membre dans le menu de gestion des utilisateurs
add_action('manage_users_custom_column', 'gus_custom_field_value', 20, 3);
add_filter('manage_users_columns', 'gus_add_custom_field', 20, 1);

add_action('admin_menu', 'gus_admin_panel');

if ( function_exists('register_uninstall_hook') )
	register_uninstall_hook(__FILE__, 'gus_uninstall');

add_action('plugins_loaded', 'gus_init');


?>
